/**
  * File: DomainGroupHandlerBaseImpl.java
  * Content: Defines an abstract RMI class to implement the DomainGroupHandler interface
  * Author: LuisM Pena
  * Date: 29th November 2000
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

/**
  * Implementation of the GroupMember CORBA interface.
  **/
public abstract class DomainGroupHandlerBaseImpl extends DomainGroupHandlerPOA
{

  public DomainGroupHandlerBaseImpl() throws Exception
  {
    this(true);
  }

  public DomainGroupHandlerBaseImpl(boolean active) throws Exception
  {
    if (active)
      activate();
  }

  public void activate() throws Exception
  {
    if (thisDomainGroupHandler==null)
    {
      id = sensei.middleware.util.ORBcentral.getPOA().activate_object(this);
      thisDomainGroupHandler = DomainGroupHandlerHelper.narrow
          (sensei.middleware.util.ORBcentral.getPOA().id_to_reference(id));
    }
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (thisDomainGroupHandler!=null)
        sensei.middleware.util.ORBcentral.getPOA().deactivate_object(id);
      thisDomainGroupHandler=null;
    }
  }

  public final DomainGroupHandler theDomainGroupHandler()
  {
    return thisDomainGroupHandler;
  }

  protected DomainGroupHandler thisDomainGroupHandler;
  byte[] id;
};

