/**
  * File: DomainGroupUserBaseImpl.java
  * Content: Defines an abstract corba class to implement the DomainGroupUSer interface
  * Author: LuisM Pena
  * Date: 25th July 2001
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

/**
  * Implementation of the DomainGroupUser CORBA interface.
  **/
public abstract class DomainGroupUserBaseImpl extends DomainGroupUserPOA
{

  public DomainGroupUserBaseImpl() throws Exception
  {
    this(true);
  }

  public DomainGroupUserBaseImpl(boolean active) throws Exception
  {
    if (active)
      activate();
  }

  public void activate() throws Exception
  {
    if (thisDomainGroupUser==null)
    {
      id = sensei.middleware.util.ORBcentral.getPOA().activate_object(this);
      thisDomainGroupUser = DomainGroupUserHelper.narrow
          (sensei.middleware.util.ORBcentral.getPOA().id_to_reference(id));
    }
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (thisDomainGroupUser!=null)
        sensei.middleware.util.ORBcentral.getPOA().deactivate_object(id);
      thisDomainGroupUser=null;
    }
  }

  public final DomainGroupUser theDomainGroupUser()
  {
    return thisDomainGroupUser;
  }

  protected DomainGroupUser thisDomainGroupUser;
  byte[] id;
};

