/**
  * File: PropertiesListenerBaseImpl.java
  * Content: Defines an abstract corba class to implement the PropertiesListener interface
  * Author: LuisM Pena
  * Date: 25th July 2001
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

/**
  * Implementation of the DomainGroupUser CORBA interface.
  **/
public abstract class PropertiesListenerBaseImpl extends PropertiesListenerPOA
{

  public PropertiesListenerBaseImpl() throws Exception
  {
    this(true);
  }

  public PropertiesListenerBaseImpl(boolean active) throws Exception
  {
    if (active)
      activate();
  }

  public void activate() throws Exception
  {
    if (thisPropertiesListener==null)
    {
      id = sensei.middleware.util.ORBcentral.getPOA().activate_object(this);
      thisPropertiesListener = PropertiesListenerHelper.narrow
          (sensei.middleware.util.ORBcentral.getPOA().id_to_reference(id));
    }
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (thisPropertiesListener!=null)
        sensei.middleware.util.ORBcentral.getPOA().deactivate_object(id);
      thisPropertiesListener=null;
    }
  }

  public final PropertiesListener thePropertiesListener()
  {
    return thisPropertiesListener;
  }

  protected PropertiesListener thisPropertiesListener;
  byte[] id;
};

