/**
  * File: MapStringSetBaseImpl.java
  * Content: Implementation of the MapStringSet
  * Author: LuisM Pena
  * Date: 18th November 2001
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

/**
  * Implementation of the MapStringSet
  **/
public abstract class MapStringSetBaseImpl extends MapStringSetPOA
{
  public MapStringSetBaseImpl() throws Exception
  {
    id = sensei.middleware.util.ORBcentral.getPOA().activate_object(this);
    thisMapStringSet = MapStringSetHelper.narrow
        (sensei.middleware.util.ORBcentral.getPOA().id_to_reference(id));
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (thisMapStringSet!=null)
        sensei.middleware.util.ORBcentral.getPOA().deactivate_object(id);
      thisMapStringSet=null;
    }
  }

  public final MapStringSet theMapStringSet()
  {
    return thisMapStringSet;
  }

  protected MapStringSet thisMapStringSet;
  byte[] id;
};
