/**
  * File: SetMemberInfoBaseImpl.java
  * Content: Implementation of the SetMemberInfo
  * Author: LuisM Pena
  * Date: 18th November 2001
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

/**
  * Implementation of the SetMemberInfo
  **/
public abstract class SetMemberInfoBaseImpl extends SetMemberInfoPOA
{
  public SetMemberInfoBaseImpl() throws Exception
  {
    id = sensei.middleware.util.ORBcentral.getPOA().activate_object(this);
    thisSetMemberInfo = SetMemberInfoHelper.narrow
        (sensei.middleware.util.ORBcentral.getPOA().id_to_reference(id));
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (thisSetMemberInfo!=null)
        sensei.middleware.util.ORBcentral.getPOA().deactivate_object(id);
      thisSetMemberInfo=null;
    }
  }

  public final SetMemberInfo theSetMemberInfo()
  {
    return thisSetMemberInfo;
  }

  protected SetMemberInfo thisSetMemberInfo;
  byte[] id;
};
