/**
  * File: SetMemberInfoObserverBaseImpl.java
  * Content: Implementation of the SetMemberInfoObserver
  * Author: LuisM Pena
  * Date: 18th November 2001
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

/**
  * Implementation of the SetMemberInfoObserver
  **/
public abstract class SetMemberInfoObserverBaseImpl extends SetMemberInfoObserverPOA
{
  public SetMemberInfoObserverBaseImpl() throws Exception
  {
    id = sensei.middleware.util.ORBcentral.getPOA().activate_object(this);
    thisSetMemberInfoObserver = SetMemberInfoObserverHelper.narrow
        (sensei.middleware.util.ORBcentral.getPOA().id_to_reference(id));
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (thisSetMemberInfoObserver!=null)
        sensei.middleware.util.ORBcentral.getPOA().deactivate_object(id);
      thisSetMemberInfoObserver=null;
    }
  }

  public final SetMemberInfoObserver theSetMemberInfoObserver()
  {
    return thisSetMemberInfoObserver;
  }

  protected SetMemberInfoObserver thisSetMemberInfoObserver;
  byte[] id;
};
