/**
  * File: SubgroupException.java
  * Content: Internal exception produced when a subgroup is not reachable
  * Author: LuisM Pena
  * Date: 25th July 2001
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.domains;

/**
  * Internal exception produced when a subgroup is not reachable
  **/
class SubgroupException extends Exception
{
  public SubgroupException(int subgroupId, Exception reason)
  {
    Trace.code("SubgroupException.java -> SubgroupException ( int subgroupId , Exception reason )");
    this.subgroupId = subgroupId;
    this.reason = reason.toString();
  }
  public String toString()
  {
    Trace.code("SubgroupException.java -> String toString ( )");
    return "Exception produced in subgroup " + subgroupId + " by " + reason;
  }
  int subgroupId;
  String reason;
}

