/**
  * File: SendTokenChannelRequester.java
  * Content: Defines a channel requester to send the token
  * Author: LuisM Pena
  * Date: 1st August 2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.gms;

import sensei.middleware.gms.SenseiGMSMember;
import sensei.middleware.gms.Token;


/**
  * Defines a channel requester to send the token
  **/
class SendTokenChannelRequester implements ChannelRequester
{

  public SendTokenChannelRequester(int thisMember)
  {
    Trace.code("SendTokenChannelRequester.java -> SendTokenChannelRequester ( int thisMember )");
    this.thisMember = thisMember;
  }

  public void setTokenToSend(Token token)
  {
    Trace.code("SendTokenChannelRequester.java -> void setTokenToSend ( Token token )");
    this.token = token;
  }

  public boolean invokeMember(CommunicationChannel channel)
  {
    Trace.code("SendTokenChannelRequester.java -> boolean invokeMember ( CommunicationChannel channel )");
    assert token!=null && channel!=null;

    boolean ret;

    SenseiGMSMember channelMember = channel.getLink();

    assert channelMember!=null;

    try
    {
      Trace.code("SendTokenChannelRequester.java -> boolean invokeMember [2] on " + channelMember.getGroupMemberId());
      ret=channelMember.receiveToken(thisMember, token) && channel.isReliable();
    }
    catch(Exception ex)
    {
      ret=false;
      Trace.handledException(ex);
    }
    return ret;
  }

  int 	thisMember;
  Token token;
}
