/**
  * File: WrongConfirmMessagesChannelRequester.java
  * Content: ConfirmMessagesChannelRequester with wrong behaviour
  * Author: LuisM Pena
  * Date: 12th August 2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.gms;

import sensei.middleware.gms.Message;
import sensei.middleware.gms.MessageId;


/**
  * ConfirmMessagesChannelRequester with wrong behaviour
  **/
class WrongConfirmMessagesChannelRequester extends ConfirmMessagesChannelRequester
{

  public WrongConfirmMessagesChannelRequester(int owner)
  {
    super (owner);
    Trace.code("WrongConfirmMessagesChannelRequester.java -> WrongConfirmMessagesChannelRequester ( int owner )");
    invocation = 0;
  }

  public void setMessageIdToConfirm(MessageId messageId)
  {
    super.setMessageIdToConfirm(messageId);
    Trace.code("WrongConfirmMessagesChannelRequester.java -> void setMessageIdToConfirm ( MessageId messageId )");
    invocation = 0;
  }

  public boolean invokeMember(CommunicationChannel channel)
  {
    Trace.code("WrongConfirmMessagesChannelRequester.java -> boolean invokeMember ( CommunicationChannel channel )");
    assert channel!=null;
    boolean invokeSuper = false;;
    if (channel.getLinkId()==thisMember)
      invokeSuper = true;
    else
      invokeSuper = invocation++==0;
    boolean ret = invokeSuper? super.invokeMember(channel) : false;
    return ret;
  }

  int invocation;
}
