/**
  * File: 		MessageC.java
  * Content: 	part of the RMI specification of sensei domains
  *           Message c is the reply message sent from a DomainGroupHandler that
  *           has received the message p. It contains its properties, and the
  *           coordination phases of the subgroups
  * Author: 	LuisM Pena
  * Date: 		27th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/


package sensei.middleware.domains;
/**
 *  Message c is the reply message sent from a DomainGroupHandler that
 *  has received the message p. It contains its properties, and the
 *  coordination phases of the subgroups
 */
public class MessageC extends DomainMessage
{
  public int viewId; //message can only be processed on the right view, depending on the model
  public SubgroupCoordination[] coordinations;
  public boolean containOwnProperties; //true if the next field props is valid
  public Property[] props; //properties of the member being coordinated
};
