/**
  * File: 		StateHandler.java
  * Content: 	part of the RMI specification of sensei domains
  *           Defines the most extended interface for state transfer
  * Author: 	LuisM Pena
  * Date: 		27th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/


package sensei.middleware.domains;

import java.rmi.RemoteException;

/**
  * Defines the most extended interface for state transfer
  */
public interface StateHandler extends BasicStateHandler
{
  public void syncTransfer (int coordinator, PhaseCoordinationHolder phase) throws RemoteException;

  public void interruptTransfer (PhaseCoordinationHolder phase) throws RemoteException;

  public void continueTransfer (int[] joiningMembers,
                                PhaseCoordinationHolder coordinator,
                                PhaseCoordination joining) throws RemoteException;
}
