/**
  * File: SetMemberInfoObserverBaseImpl.java
  * Content: Implementation of the SetMemberInfoObserver
  * Author: LuisM Pena
  * Date: 		1st December 2001
  * Version:  0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

/**
  * Implementation of the SetMemberInfoObserver RMI interface.
  **/
public abstract class SetMemberInfoObserverBaseImpl extends UnicastRemoteObject
  implements SetMemberInfoObserver
{

  public SetMemberInfoObserverBaseImpl() throws Exception
  {
    thisSetMemberInfoObserver=this;
  }

  public SetMemberInfoObserverBaseImpl(boolean activate) throws Exception
  {
    if (!activate)
      deactivate();
  }

  public void activate() throws Exception
  {
    if (thisSetMemberInfoObserver==null)
    {
      thisSetMemberInfoObserver=this;
      exportObject(this);
    }
  }

  public void deactivate() throws RemoteException
  {
    synchronized (this)
    {
      if (thisSetMemberInfoObserver!=null)
        unexportObject(thisSetMemberInfoObserver,true);
      thisSetMemberInfoObserver=null;
    }
  }

  public final SetMemberInfoObserver theSetMemberInfoObserver()
  {
    return thisSetMemberInfoObserver;
  }

  protected SetMemberInfoObserver thisSetMemberInfoObserver;
}
