/**
  * File: Token.java
  * Content: part of the RMI specification of members with reliable multicast
  *          communications, based on the virtual synchronous model
  * Author: LuisM Pena
  * Date: 16th August 2000
  * Version: 0.80.00
  * Last change:
  *
  * Comments: Each token must be defined in such a way that its regeneration 
	* creates a completely diferent id.
  *
  **/

package sensei.middleware.gms;

final public class Token implements java.io.Serializable
{
    public
    Token()
    {
    }

    public
    Token(int creator,
          int id)
    {
        this.creator = creator;
        this.id = id;
    }

    public int creator;
    public int id;
}
